/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package javax.management.remote;

import javax.management.Notification;

/**
 * @author <a href="mailto:tom.elrod@jboss.com">Tom Elrod</a>
 */
public class JMXConnectionNotification extends Notification
{
   private static final long serialVersionUID = -2331308725952627538l;

   public static final String OPENED = "jmx.remote.connection.opened";
   public static final String CLOSED = "jmx.remote.connection.closed";
   public static final String FAILED = "jmx.remote.connection.failed";
   public static final String NOTIFS_LOST = "jmx.remote.connection.notifs.lost";

   private String connectionId = null;

   public JMXConnectionNotification(String type, Object source, String connectionId,
                                    long sequenceNumber, String message, Object userData)
   {
      super(type, source, sequenceNumber, System.currentTimeMillis(), message);
      this.connectionId = connectionId;
      setUserData(userData);
   }

   public String getConnectionId()
   {
      return connectionId;
   }
}